"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CourseDetailsController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const courseDetails_service_1 = require("../services/courseDetails.service");
let CourseDetailsController = class CourseDetailsController {
    constructor(courseDetailsService) {
        this.courseDetailsService = courseDetailsService;
    }
    async getCourseDetails(courseId) {
        try {
            const courseDetails = await this.courseDetailsService.getCourseDetails(courseId);
            return courseDetails;
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getCourseWiseSection(courseId, studentId = null) {
        try {
            const courseDetails = await this.courseDetailsService.getCourseWiseSection(courseId, studentId);
            return courseDetails;
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getLessonDetails(lessonId) {
        try {
            const courseDetails = await this.courseDetailsService.getLessonDetails(lessonId);
            return courseDetails;
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async deleteLesson(lessonId) {
        try {
            await this.courseDetailsService.deleteLessonWithQuestionsAssignment(lessonId);
            return { success: true, message: 'Lesson and associated questions/assignments deleted successfully' };
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getCoursesSummary(courseType) {
        try {
            const courseDetails = await this.courseDetailsService.getCoursesSummary(courseType);
            return courseDetails;
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
};
__decorate([
    (0, common_1.Get)('course/:id'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseDetailsController.prototype, "getCourseDetails", null);
__decorate([
    (0, common_1.Get)('get-course-section/:id/:studentId?'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], CourseDetailsController.prototype, "getCourseWiseSection", null);
__decorate([
    (0, common_1.Get)('get-lesson/:id'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseDetailsController.prototype, "getLessonDetails", null);
__decorate([
    (0, common_1.Delete)('lesson/:id'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseDetailsController.prototype, "deleteLesson", null);
__decorate([
    (0, common_1.Get)('get-course-summary/:courseType'),
    openapi.ApiResponse({ status: 200, type: Object }),
    __param(0, (0, common_1.Param)('courseType')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseDetailsController.prototype, "getCoursesSummary", null);
CourseDetailsController = __decorate([
    (0, swagger_1.ApiTags)("CoursesDetails"),
    (0, common_1.Controller)('course-details'),
    __metadata("design:paramtypes", [courseDetails_service_1.CourseDetailsService])
], CourseDetailsController);
exports.CourseDetailsController = CourseDetailsController;
//# sourceMappingURL=courseDetails.controller.js.map