import { Enrollments } from "src/schemas/enrollments.schema";
import { EnrollmentsService } from "src/services/enrollments.service";
export declare class EnrollmentsController {
    private enrollmentsService;
    constructor(enrollmentsService: EnrollmentsService);
    getAllEnrollments(): Promise<Enrollments[]>;
    create(enrollment: Enrollments): Promise<Enrollments>;
    edit(enrollmentId: string, updatedEnrollment: Enrollments): Promise<Enrollments>;
    getById(enrollmentId: string): Promise<Enrollments>;
    getByStudentId(studentId: string): Promise<Enrollments[]>;
    getByCourseId(courseId: string): Promise<Enrollments[]>;
    getByInstructorId(instructorId: string): Promise<Enrollments[]>;
    getByStudentAndCourseId(courseId: string, studentId: string): Promise<Enrollments>;
    delete(enrollmentId: string): Promise<void>;
}
