import { Feedback } from 'src/schemas/feedback.schema';
import { FeedbackService } from 'src/services/feedback.service';
export declare class FeedbackController {
    private readonly feedbackService;
    constructor(feedbackService: FeedbackService);
    create(feedback: Feedback): Promise<Feedback>;
    edit(feedbackId: string, updatedFeedback: Feedback): Promise<Feedback>;
    getAll(): Promise<Feedback[]>;
    getFeedbackByStatus(status: boolean): Promise<Feedback[]>;
    getById(feedbackId: string): Promise<Feedback>;
    getByUserId(userId: string): Promise<Feedback[]>;
    getByCourseId(courseId: string): Promise<Feedback[]>;
    delete(feedbackId: string): Promise<void>;
}
