"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeedbackController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const feedback_schema_1 = require("../schemas/feedback.schema");
const feedback_service_1 = require("../services/feedback.service");
let FeedbackController = class FeedbackController {
    constructor(feedbackService) {
        this.feedbackService = feedbackService;
    }
    async create(feedback) {
        try {
            return await this.feedbackService.create(feedback);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async edit(feedbackId, updatedFeedback) {
        try {
            return await this.feedbackService.edit(feedbackId, updatedFeedback);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getAll() {
        try {
            return await this.feedbackService.getAll();
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getFeedbackByStatus(status) {
        try {
            return await this.feedbackService.getFeedbackByStatus(status);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getById(feedbackId) {
        try {
            return await this.feedbackService.getById(feedbackId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getByUserId(userId) {
        try {
            return await this.feedbackService.getByUserId(userId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByCourseId(courseId) {
        try {
            return await this.feedbackService.getByCourseId(courseId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async delete(feedbackId) {
        try {
            await this.feedbackService.delete(feedbackId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
__decorate([
    (0, common_1.Post)('create'),
    openapi.ApiResponse({ status: 201, type: require("../schemas/feedback.schema").Feedback }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [feedback_schema_1.Feedback]),
    __metadata("design:returntype", Promise)
], FeedbackController.prototype, "create", null);
__decorate([
    (0, common_1.Put)('edit/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/feedback.schema").Feedback }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, feedback_schema_1.Feedback]),
    __metadata("design:returntype", Promise)
], FeedbackController.prototype, "edit", null);
__decorate([
    (0, common_1.Get)('get-all'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/feedback.schema").Feedback] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], FeedbackController.prototype, "getAll", null);
__decorate([
    (0, common_1.Get)('get-feedback-by-status/:status'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/feedback.schema").Feedback] }),
    __param(0, (0, common_1.Param)('status')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Boolean]),
    __metadata("design:returntype", Promise)
], FeedbackController.prototype, "getFeedbackByStatus", null);
__decorate([
    (0, common_1.Get)('get-by-id/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/feedback.schema").Feedback }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], FeedbackController.prototype, "getById", null);
__decorate([
    (0, common_1.Get)('get-by-user/:userId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/feedback.schema").Feedback] }),
    __param(0, (0, common_1.Param)('userId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], FeedbackController.prototype, "getByUserId", null);
__decorate([
    (0, common_1.Get)('get-by-course/:courseId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/feedback.schema").Feedback] }),
    __param(0, (0, common_1.Param)('courseId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], FeedbackController.prototype, "getByCourseId", null);
__decorate([
    (0, common_1.Delete)('delete/:id'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], FeedbackController.prototype, "delete", null);
FeedbackController = __decorate([
    (0, swagger_1.ApiTags)("Feedbacks"),
    (0, common_1.Controller)('feedbacks'),
    __metadata("design:paramtypes", [feedback_service_1.FeedbackService])
], FeedbackController);
exports.FeedbackController = FeedbackController;
//# sourceMappingURL=feedback.controller.js.map