import { Request } from "express";
import { User } from "src/schemas/user.schema";
import { UserService } from "src/services/user.service";
import { UserDTO } from "src/viewModel/user.dto";
export declare class UserController {
    private userService;
    constructor(userService: UserService);
    findAll(): Promise<UserDTO[]>;
    findByRoleAndStatus(role?: string, status?: boolean): Promise<User[]>;
    getById(id?: string): Promise<UserDTO>;
    create(image: Express.Multer.File, user: User): Promise<User>;
    edit(userId: string, image: Express.Multer.File, updatedUser: User): Promise<User>;
    delete(userId: string): Promise<void>;
    activateUser(userId: string, status: boolean): Promise<User>;
    login({ email, password, phone }: {
        email?: string | undefined;
        password?: string | undefined;
        phone?: string | undefined;
    }, req: Request): Promise<{
        accessToken: string;
        refreshToken: string;
    }>;
    refreshAccessToken({ refreshToken }: {
        refreshToken: string;
    }): Promise<{
        accessToken: string;
    }>;
    getMe(id?: string): Promise<User>;
    logout({ refreshToken }: {
        refreshToken: string;
    }): Promise<void>;
    resetPassword(userId: string, password: string): Promise<User>;
}
